#pragma once

#include <string>
#include <cstdint>

enum UserType {
	BOT,
	DELETED,
	REGULAR,
	UNKNOWN,
};

const std::string UserTypeTypes[] {"bot", "deleted", "regular", "unknown"};

const std::string& convertUserType(UserType);
UserType convertUserType(const std::string& in);

// complete user infomation
struct User {
	int64_t tgid;
	std::string firstname;
	std::string lastname;
	std::string username;
	std::string phonenumber;
	bool isContact;
	bool isMutalContact;
	bool isVerified;
	bool isSupport;
	std::string restriction;
	bool isScam;
	bool haveAccess;
	UserType type;

	bool operator==(const User&) const;
	bool operator!=(const User&) const;
};