#pragma once

#include <cstdint>
#include <string>

namespace UserStatus {

enum UserStatus : uint8_t {
	EMPTY = 0,
	ONLINE,
	OFFLINE,
	RECENTLY,
	LASTWEEK,
	LASTMONTH
};

UserStatus getStatus(int32_t status);
const std::string& statustoString(UserStatus);

}

namespace ChatAction {

enum ChatAction : uint8_t {
	CANCEL = 0,
	CHOOSINGCONTACT,
	CHOOSINGLOCATION,
	RECORDINGVIDEO,
	RECORDINGVIDEONOTE,
	RECORDINGVOICENOTE,
	PLAYGAME,
	TYPING,
	UPLOADINGDOCUMENT,
	UPLOADINGPHOTO,
	UPLODAINGVIDEO,
	UPLOADINGVIDEONOTE,
	UPLOADINGVOICENOTE
};

ChatAction getAction(int32_t status);
const std::string& actiontoString(ChatAction);

}