#include <Log.h>

#include <fstream>
#include <signal.h>

#include "tgtui.h"

static TgTUI* tui = nullptr;

void sig_handler(int sig_num) {
	Log::info << "signalHandler triggered";
	if(tui)
		tui->stop();
	(void) sig_num;
}

int main(int argc, const char** argv) {
	Log::Deleter log;
	Log::setConsoleLogLevel(Log::Level::off);
	Log::addLogfile("log.txt", Log::Level::trace, true);

	Log::info << "Hello, World!";

	TgTUI tgtui;
	tui = &tgtui;

	//register signal handler
	signal(SIGINT, sig_handler);

	tgtui.run();

	tui = nullptr;

	return 0;
}
